"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _http = _interopRequireDefault(require("./http"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var NotificationWeb = /*#__PURE__*/function () {
  function NotificationWeb() {
    _classCallCheck(this, NotificationWeb);
  }
  _createClass(NotificationWeb, null, [{
    key: "getToken",
    value:
    /**
     *
     * @param onSuccess
     * @param onFail
     */
    function getToken(onSuccess, onFail) {
      this.messaging.getToken().then(function (token) {
        var notification = {
          type: 'web',
          value: token
        };
        onSuccess(notification);
      }).catch(onFail);
    }

    /**
     *
     * @param token
     */
  }, {
    key: "setToken",
    value: function setToken(token) {
      _http.default.post('/notification/token/', token).then(function (user) {
        window.localStorage.setItem('auth', JSON.stringify(user));
      }).catch(function (err) {
        return console.log(err);
      });
    }

    /**
     *
     * @param user
     */
  }, {
    key: "checkToken",
    value: function checkToken(user) {
      // first request the permission. Then gets the token
      console.log("checkToken");
      this.messaging.requestPermission().then(function () {
        console.log("checkToken B");
        NotificationWeb.getToken(function (token) {
          console.log("checkToken C", token);
          if (!user.notification || !user.notification.web.token.includes(token.value)) {
            console.log("checkToken D");
            NotificationWeb.setToken(token);
          }
        });
      }).catch(function (err) {
        throw err;
      });
    }

    /**
     *
     * @param onSuccess
     * @param onFail
     */
  }, {
    key: "handleMessage",
    value: function handleMessage(onSuccess, onFail) {
      this.messaging.onMessage(onSuccess);
    }

    /**
     *
     * @param onSuccess
     * @param onFail
     */
  }, {
    key: "onTokenRefresh",
    value: function onTokenRefresh(onSuccess, onFail) {
      this.messaging.onTokenRefresh(onSuccess, onFail);
    }

    /**
     *
     * @param firebase
     */
  }, {
    key: "setup",
    value: function setup(firebase) {
      try {
        this.firebase = firebase;
        this.messaging = firebase.messaging();
        if (!this.messaging) {
          throw new Error('Notification.setup error: Messaging is missing');
        }
      } catch (error) {
        throw error;
      }
    }
  }]);
  return NotificationWeb;
}();
_defineProperty(NotificationWeb, "firebase", void 0);
_defineProperty(NotificationWeb, "messaging", void 0);
var _default = NotificationWeb;
exports.default = _default;