"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _text = _interopRequireDefault(require("./text"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var ObjHandler = /*#__PURE__*/function () {
  function ObjHandler() {
    _classCallCheck(this, ObjHandler);
  }
  _createClass(ObjHandler, null, [{
    key: "getChild",
    value:
    // get child or child of child or child of child of child...
    // Key can be "key.otherKey"
    function getChild(obj, key) {
      var arr = key.split(".");
      while (arr.length && (obj = obj[arr.shift()]));
      return obj;
    }
  }, {
    key: "sortByKey",
    value: function sortByKey(objArray, key) {
      return objArray.sort(function (item, lastItem) {
        var name = _text.default.replaceSpecial(item[key].toUpperCase());
        var last = _text.default.replaceSpecial(lastItem[key].toUpperCase());
        if (name < last) {
          return -1;
        } else if (name > last) {
          return 1;
        } else {
          return 0;
        }
      });
    }
  }]);
  return ObjHandler;
}();
// Remove objects with a duplicate key from array of objects
// (will keep the last found)
_defineProperty(ObjHandler, "removeDuplicates", function (objArray, key) {
  var newArray = [];
  var _loop = function _loop(index) {
    var foundIndex = null;
    var found = newArray.find(function (relation, i) {
      if (ObjHandler.getChild(relation, key) === ObjHandler.getChild(objArray[index], key)) {
        foundIndex = i;
        return true;
      }
      return false;
    });
    if (found === undefined) {
      newArray.push(objArray[index]);
    } else {
      newArray[foundIndex] = found;
    }
  };
  for (var index in objArray) {
    _loop(index);
  }
  return newArray;
});
var _default = ObjHandler;
exports.default = _default;