"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.pluralize = exports.default = exports.config = void 0;
var Plural = function () {
  var specialCases = {};
  function config(cases) {
    specialCases = cases;
    return specialCases;
  }
  function pluralize(word, value) {
    var isFirstLetterUpperCase = word.match(/^[A-Z]/);
    word = word.toLowerCase();
    var singular = word;
    var plural = word + 's';
    if (specialCases[word]) {
      plural = specialCases[word];
    }
    if (isFirstLetterUpperCase) plural = plural.replace(/^([a-z])/, function (p1) {
      return p1.toUpperCase();
    });
    if (value > 1) return plural;
    return singular;
  }
  return {
    config: config,
    pluralize: pluralize
  };
}();
var _default = Plural;
exports.default = _default;
var pluralize = Plural.pluralize;
exports.pluralize = pluralize;
var config = Plural.config;
exports.config = config;